﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace ChartTest
{
    public class MainWindowViewModel : INotifyPropertyChanged
    {

        public MainWindowViewModel ()
	    {
            ChartData = new ObservableCollection<StripChartDataPoint>();

            DateTime dt = DateTime.Now;
            ChartMin = dt.AddSeconds(-1);
            ChartMax = dt.AddSeconds(5);

            ChartData.Add(new StripChartDataPoint() { Date = dt, Value = 4 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(200), Value = 5 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(400), Value = 6 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(500), Value = null }); // missing value, change to a number and things look better
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(600), Value = 6 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(700), Value = 5 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(2000), Value = 7 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(3000), Value = 4 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(4000), Value = 2 });
            ChartData.Add(new StripChartDataPoint() { Date = dt.AddMilliseconds(4500), Value = 3 });
        }

        private DateTime _chartMin;
        public DateTime ChartMin
        {
            get
            {
                return _chartMin;
            }
            set
            {
                _chartMin = value;
                RaisePropertyChanged("ChartMin");
            }
        }

        private DateTime _chartMax;
        public DateTime ChartMax
        {
            get
            {
                return _chartMax;
            }
            set
            {
                _chartMax = value;
                RaisePropertyChanged("ChartMax");
            }
        }

        private ObservableCollection<StripChartDataPoint> _chartData;
        public ObservableCollection<StripChartDataPoint> ChartData
        {
            get
            {
                return _chartData;
            }
            set
            {
                _chartData = value;
                RaisePropertyChanged("ChartData");
            }
        }

        private ObservableCollection<StripChartDataPoint> _chartData2;
        public ObservableCollection<StripChartDataPoint> ChartData2
        {
            get
            {
                return _chartData2;
            }
            set
            {
                _chartData2 = value;
                RaisePropertyChanged("ChartData2");
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;
        // Create the OnPropertyChanged method to raise the event
        protected void RaisePropertyChanged(string name)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(name));
            }
        }

    }

    public class StripChartDataPoint
    {
        private double? _value;
        public double? Value
        {
            get { return _value; }
            set
            {
                _value = value;
            }
        }
        public DateTime Date { get; set; }
    }

}
